; kickstart1.3/theme.jl

;; Copyright (C) 2000 Jess Bravo lvarez <jba@pobox.com>
;;
;; Based on the screenshots from Thomas Kaehn <tkaehn@gmx.de>

;; raise button definition

  (def-frame-class raise-button '((cursor . exchange))
     (bind-keys raise-button-keymap "Button1-Off" 'raise-window)
     (bind-keys raise-button-keymap "Button3-Off" 'maximize-window-toggle))

;; lower button definition

  (def-frame-class lower-button '((cursor . exchange))
     (bind-keys lower-button-keymap "Button1-Off" 'lower-window)
     (bind-keys lower-button-keymap "Button3-Off" 'iconify-window))

(let*

  (

;; the font

    (font (get-font "-*-fixed-bold-r-normal-*-14-*-*-*-*-iso8859-*"))

;; title width function

    (title-width
      (lambda (w)
        (let
            ((w-width (car (window-dimensions w))))
          (max 0 (min (- w-width 50) (text-width (window-name w) font))))))

;; images

    (title-images
      (let ((img1 (make-image "title_inact.png"))
            (img2 (make-image "title_active.png")))
        (image-put img1 'tiled t)
        (image-put img2 'tiled t)
        (list img1 img2)))

    (title-fill-images (make-image "title_fill.png"))

    (close-images (list (make-image "close.png")
                        nil nil
                        (make-image "close_click.png")))

    (raise-images (list (make-image "raise.png")
                        nil nil
                        (make-image "raise_click.png")))

    (lower-images (list (make-image "lower.png")
                        nil nil
                        (make-image "lower_click.png")))

    (border-images (make-image "border.png"))


;; frame layout

    (frame
     `(

    ;; title

        ((background . ,title-fill-images)
         (foreground . ,(get-color-rgb 0 21760 43250))
         (font . ,font)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (top-edge . -20)
         (left-edge . 27)
         (width . ,(lambda (w) (+ (title-width w) 8)))
         (class . title)
        )

        ((background . ,title-images)
         (top-edge . -20)
         (right-edge . 54)
         (left-edge . ,(lambda (w) (+ (title-width w) 35)))
         (class . title)
        )

        ((background . ,title-fill-images)
         (top-edge . -20)
         (right-edge . 51)
         (class . title)
        )

    ;; close button

        ((background . ,close-images)
         (top-edge . -20)
         (left-edge . 1)
         (class . close-button)
        )

    ;; lower button

        ((background . ,lower-images)
         (top-edge . -20)
         (right-edge . 27)
         (class . lower-button)
        )

    ;; raise button

        ((background . ,raise-images)
         (top-edge . -20)
         (right-edge . 1)
         (class . raise-button)
        )

    ;; top-left corner

        ((background . ,title-fill-images)
         (top-edge . -20)
         (left-edge . -2)
         (class . top-left-corner)
        )

    ;; top-right corner

        ((background . ,title-fill-images)
         (top-edge . -20)
         (right-edge . -2)
         (class . top-right-corner)
        )

    ;; left border

        ((background . ,border-images)
         (top-edge . 0)
         (bottom-edge . 0)
         (left-edge . -2)
         (class . left-border)
        )

    ;; right border

        ((background . ,border-images)
         (top-edge . 0)
         (bottom-edge . 0)
         (right-edge . -2)
         (class . right-border)
        )

    ;; bottom border

        ((background . ,border-images)
         (bottom-edge . -2)
         (right-edge . 0)
         (left-edge . 0)
         (class . bottom-border)
        )

    ;; bottom-left corner

        ((background . ,border-images)
         (bottom-edge . -2)
         (left-edge . -2)
         (class . bottom-left-corner)
        )

    ;; bottom-right corner

        ((background . ,border-images)
         (bottom-edge . -2)
         (right-edge . -2)
         (class . bottom-right-corner)
        )
      )
    )

    (shaped-frame
     `(

    ;; title

        ((background . ,title-fill-images)
         (foreground . ,(get-color-rgb 0 21760 43250))
         (font . ,font)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (top-edge . -20)
         (left-edge . 27)
         (width . ,(lambda (w) (+ (title-width w) 8)))
         (class . title)
        )

        ((background . ,title-images)
         (top-edge . -20)
         (right-edge . 54)
         (left-edge . ,(lambda (w) (+ (title-width w) 35)))
         (class . title)
        )

        ((background . ,title-fill-images)
         (top-edge . -20)
         (right-edge . 51)
         (class . title)
        )

    ;; close button

        ((background . ,close-images)
         (top-edge . -20)
         (left-edge . 1)
         (class . close-button)
        )

    ;; lower button

        ((background . ,lower-images)
         (top-edge . -20)
         (right-edge . 27)
         (class . lower-button)
        )

    ;; raise button

        ((background . ,raise-images)
         (top-edge . -20)
         (right-edge . 1)
         (class . raise-button)
        )

    ;; top-left corner

        ((background . ,title-fill-images)
         (top-edge . -20)
         (left-edge . -2)
         (class . top-left-corner)
        )

    ;; top-right corner

        ((background . ,title-fill-images)
         (top-edge . -20)
         (right-edge . -2)
         (class . top-right-corner)
        )
      )
    )

    (transient-frame
     `(

    ;; title

        ((background . ,title-fill-images)
         (foreground . ,(get-color-rgb 0 21760 43250))
         (font . ,font)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (top-edge . -20)
         (left-edge . 27)
         (width . ,(lambda (w) (+ (title-width w) 8)))
         (class . title)
        )

        ((background . ,title-images)
         (top-edge . -20)
         (right-edge . 1)
         (left-edge . ,(lambda (w) (+ (title-width w) 35)))
         (class . title)
        )

    ;; close button

        ((background . ,close-images)
         (top-edge . -20)
         (left-edge . 1)
         (class . close-button)
        )

    ;; top-left corner

        ((background . ,title-fill-images)
         (top-edge . -20)
         (left-edge . -2)
         (class . top-left-corner)
        )

    ;; top-right corner

        ((background . ,title-fill-images)
         (top-edge . -20)
         (right-edge . -2)
         (class . top-right-corner)
        )

    ;; left border

        ((background . ,border-images)
         (top-edge . 0)
         (bottom-edge . 0)
         (left-edge . -2)
         (class . left-border)
        )

    ;; right border

        ((background . ,border-images)
         (top-edge . 0)
         (bottom-edge . 0)
         (right-edge . -2)
         (class . right-border)
        )

    ;; bottom border

        ((background . ,border-images)
         (bottom-edge . -2)
         (right-edge . 0)
         (left-edge . 0)
         (class . bottom-border)
        )

    ;; bottom-left corner

        ((background . ,border-images)
         (bottom-edge . -2)
         (left-edge . -2)
         (class . bottom-left-corner)
        )

    ;; bottom-right corner

        ((background . ,border-images)
         (bottom-edge . -2)
         (right-edge . -2)
         (class . bottom-right-corner)
        )
      )
    )

    (shaped-transient-frame
     `(

    ;; title

        ((background . ,title-fill-images)
         (foreground . ,(get-color-rgb 0 21760 43250))
         (font . ,font)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (top-edge . -20)
         (left-edge . 27)
         (width . ,(lambda (w) (+ (title-width w) 8)))
         (class . title)
        )

        ((background . ,title-images)
         (top-edge . -20)
         (right-edge . 1)
         (left-edge . ,(lambda (w) (+ (title-width w) 35)))
         (class . title)
        )

    ;; close button

        ((background . ,close-images)
         (top-edge . -20)
         (left-edge . 1)
         (class . close-button)
        )

    ;; top-left corner

        ((background . ,title-fill-images)
         (top-edge . -20)
         (left-edge . -2)
         (class . top-left-corner)
        )

    ;; top-right corner

        ((background . ,title-fill-images)
         (top-edge . -20)
         (right-edge . -2)
         (class . top-right-corner)
        )
      )
    )
  )

;; frame definition

  (add-frame-style 'kickstart1.3
    (lambda (w type)
      (cond
            ((eq type 'shaped) shaped-frame)
            ((eq type 'shaped-transient) shaped-transient-frame)
            ((eq type 'transient) transient-frame)
            ((eq type 'unframed) nil-frame)
            (t frame)
      )
    )
  )

  (call-after-property-changed
   'WM_NAME (lambda ()
              (rebuild-frames-with-style 'kickstart1.3)))

)
